//-----------------------------------------------------------------
// I-O Port M-Variables.h - Created Fred Foscalina
// These are the assignments for the m-variables
//-----------------------------------------------------------------
//
//$Modtime: 1/19/10 2:25p $
//$Revision: 3 $
//$Author: Fredf $ 

#ifndef __I_O_PORT_M_VARIABLES_H__	// don't allow multiple loads
#define __I_O_PORT_M_VARIABLES_H__

#ifndef __cplusplus
// ************************************************
// Multiplex Assignment Address
// ************************************************

// base addresses for storage of I/O bits
#define InputBaseAddr1		$10F0
#define InputBaseAddr2		$10F1
#define InputBaseAddr3		$10F2
#define OutputBaseAddr1		$10F3
#define OutputBaseAddr2		$10F4
#define OutputBaseAddr3		$10F5

// Multiplexer base M-Variables
#define InputMuxBaseMVar1	M7001
#define InputMuxBaseMVar2	M7002
#define InputMuxBaseMVar3	M7003
#define OutputMuxBaseMVar1	M7004
#define OutputMuxBaseMVar2	M7005
#define OutputMuxBaseMVar3	M7006

// M-Variables of base storage addresses
#define InputBaseMVar1		M7007
#define InputBaseMVar2		M7008
#define InputBaseMVar3		M7009
#define OutputBaseMVar1		M7010
#define OutputBaseMVar2		M7011
#define OutputBaseMVar3		M7012

// all I/O is in M7000 to M7400 address space
M7000..7399->*							// Clear all addresses

InputMuxBaseMVar1->TWS:$1				// Multiplex Port 1 Inputs
InputMuxBaseMVar2->TWS:$9				// Multiplex Port 2 Inputs
//InputMuxBaseMVar3->TWS:$11			// Multiplex Port 3 Inputs

OutputMuxBaseMVar1->TWS:$6       		// Multiplex Port 1 Outputs
//OutputMuxBaseMVar2->TWS:$E			// Multiplex Port 2 Outputs
//OutputMuxBaseMVar3->TWS:$16			// Multiplex Port 3 Outputs

InputBaseMVar1->D:InputBaseAddr1		// Address of Multiplex Port 1 Input Image
InputBaseMVar2->D:InputBaseAddr2		// Address of Multiplex Port 2 Input Image
//InputBaseMVar3->D:InputBaseAddr3		// Address of Multiplex Port 3 Input Image

OutputBaseMVar1->D:OutputBaseAddr1		// Address of Multiplex Port 1 Output Image
//OutputBaseMVar2->D:OutputBaseAddr2	// Address of Multiplex Port 2 Output Image
//OutputBaseMVar3->D:OutputBaseAddr3	// Address of Multiplex Port 3 Output Image
#endif

// ======================
// Port/Bit defines
// ======================

// ************************************************
// Inputs - Multiplex Port 1 {TWS:1} M7101-M7132
// ************************************************

#define MP1_B0      M7101
#define MP1_B1      M7102
#define MP1_B2      M7103
#define MP1_B3      M7104
#define MP1_B4      M7105
#define MP1_B5      M7106
#define MP1_B6      M7107
#define MP1_B7      M7108

#define MP1_B8      M7109
#define MP1_B9      M7110
#define MP1_B10     M7111
#define MP1_B11     M7112
#define MP1_B12     M7113
#define MP1_B13     M7114
#define MP1_B14     M7115
#define MP1_B15     M7116

#define MP1_B16     M7117
#define MP1_B17     M7118
#define MP1_B18     M7119
#define MP1_B19     M7120
#define MP1_B20     M7121
#define MP1_B21     M7122
#define MP1_B22     M7123
#define MP1_B23     M7124

#define MP1_B24     M7125
#define MP1_B25     M7126
#define MP1_B26     M7127
#define MP1_B27     M7128
#define MP1_B28     M7129
#define MP1_B29     M7130
#define MP1_B30     M7131
#define MP1_B31     M7132

// ************************************************
// Outputs - Multiplex Port 6 {TWS:6} M7301-M7332
// ************************************************

#define MP6_B0      M7301
#define MP6_B1      M7302
#define MP6_B2      M7303
#define MP6_B3      M7304
#define MP6_B4      M7305
#define MP6_B5      M7306
#define MP6_B6      M7307
#define MP6_B7      M7308

#define MP6_B8      M7309
#define MP6_B9      M7310
#define MP6_B10     M7311
#define MP6_B11     M7312
#define MP6_B12     M7313
#define MP6_B13     M7314
#define MP6_B14     M7315
#define MP6_B15     M7316

#define MP6_B16     M7317
#define MP6_B17     M7318
#define MP6_B18     M7319
#define MP6_B19     M7320
#define MP6_B20     M7321
#define MP6_B21     M7322
#define MP6_B22     M7323
#define MP6_B23     M7324

#define MP6_B24     M7325
#define MP6_B25     M7326
#define MP6_B26     M7327
#define MP6_B27     M7328
#define MP6_B28     M7329
#define MP6_B29     M7330
#define MP6_B30     M7331
#define MP6_B31     M7332

// *************************************************
// Inputs - Multiplex Port 9 {TWS:9} M7133-M7164
// *************************************************

#define MP9_B0      M7133
#define MP9_B1      M7134
#define MP9_B2      M7135
#define MP9_B3      M7136
#define MP9_B4      M7137
#define MP9_B5      M7138
#define MP9_B6      M7139
#define MP9_B7      M7140

#define MP9_B8      M7141
#define MP9_B9      M7142
#define MP9_B10     M7143
#define MP9_B11     M7144
#define MP9_B12     M7145
#define MP9_B13     M7146
#define MP9_B14     M7147
#define MP9_B15     M7148

#define MP9_B16     M7149
#define MP9_B17     M7150
#define MP9_B18     M7151
#define MP9_B19     M7152
#define MP9_B20     M7153
#define MP9_B21     M7154
#define MP9_B22     M7155
#define MP9_B23     M7156

#define MP9_B24     M7157
#define MP9_B25     M7158
#define MP9_B26     M7159
#define MP9_B27     M7160
#define MP9_B28     M7161
#define MP9_B29     M7162
#define MP9_B30     M7163
#define MP9_B31     M7164

// *************************************************
// Outputs - Multiplex Port 14 {TWS:14} M7333-M7364
// *************************************************

#define MP14_B0     M7333
#define MP14_B1     M7334
#define MP14_B2     M7335
#define MP14_B3     M7336
#define MP14_B4     M7337
#define MP14_B5     M7338
#define MP14_B6     M7339
#define MP14_B7     M7340

#define MP14_B8     M7341
#define MP14_B9     M7342
#define MP14_B10    M7343
#define MP14_B11    M7344
#define MP14_B12    M7345
#define MP14_B13    M7346
#define MP14_B14    M7347
#define MP14_B15    M7348

#define MP14_B16    M7349
#define MP14_B17    M7350
#define MP14_B18    M7351
#define MP14_B19    M7352
#define MP14_B20    M7353
#define MP14_B21    M7354
#define MP14_B22    M7355
#define MP14_B23    M7356

#define MP14_B24    M7357
#define MP14_B25    M7358
#define MP14_B26    M7359
#define MP14_B27    M7360
#define MP14_B28    M7361
#define MP14_B29    M7362
#define MP14_B30    M7363
#define MP14_B31    M7364

#ifndef __cplusplus
// *************************************************
// M Variable Address Assignment
// *************************************************

// ************************************************
// Inputs - Multiplex Port 1 {TWS:1} M7101-M7132
// ************************************************
MP1_B0->Y:InputBaseAddr1,0
MP1_B1->Y:InputBaseAddr1,1
MP1_B2->Y:InputBaseAddr1,2
MP1_B3->Y:InputBaseAddr1,3
MP1_B4->Y:InputBaseAddr1,4
MP1_B5->Y:InputBaseAddr1,5
MP1_B6->Y:InputBaseAddr1,6
MP1_B7->Y:InputBaseAddr1,7
MP1_B8->Y:InputBaseAddr1,8
MP1_B9->Y:InputBaseAddr1,9
MP1_B10->Y:InputBaseAddr1,10
MP1_B11->Y:InputBaseAddr1,11
MP1_B12->Y:InputBaseAddr1,12
MP1_B13->Y:InputBaseAddr1,13
MP1_B14->Y:InputBaseAddr1,14
MP1_B15->Y:InputBaseAddr1,15
MP1_B16->Y:InputBaseAddr1,16
MP1_B17->Y:InputBaseAddr1,17
MP1_B18->Y:InputBaseAddr1,18
MP1_B19->Y:InputBaseAddr1,19
MP1_B20->Y:InputBaseAddr1,20
MP1_B21->Y:InputBaseAddr1,21
MP1_B22->Y:InputBaseAddr1,22
MP1_B23->Y:InputBaseAddr1,23
MP1_B24->X:InputBaseAddr1,0
MP1_B25->X:InputBaseAddr1,1
MP1_B26->X:InputBaseAddr1,2
MP1_B27->X:InputBaseAddr1,3
MP1_B28->X:InputBaseAddr1,4
MP1_B29->X:InputBaseAddr1,5
MP1_B30->X:InputBaseAddr1,6
MP1_B31->X:InputBaseAddr1,7

// ************************************************
// Outputs - Multiplex Port 6 {TWS:6} M7301-M7332
// ************************************************
MP6_B0->Y:OutputBaseAddr1,0
MP6_B1->Y:OutputBaseAddr1,1
MP6_B2->Y:OutputBaseAddr1,2
MP6_B3->Y:OutputBaseAddr1,3
MP6_B4->Y:OutputBaseAddr1,4
MP6_B5->Y:OutputBaseAddr1,5
MP6_B6->Y:OutputBaseAddr1,6
MP6_B7->Y:OutputBaseAddr1,7
MP6_B8->Y:OutputBaseAddr1,8
MP6_B9->Y:OutputBaseAddr1,9
MP6_B10->Y:OutputBaseAddr1,10
MP6_B11->Y:OutputBaseAddr1,11
MP6_B12->Y:OutputBaseAddr1,12
MP6_B13->Y:OutputBaseAddr1,13
MP6_B14->Y:OutputBaseAddr1,14
MP6_B15->Y:OutputBaseAddr1,15
MP6_B16->Y:OutputBaseAddr1,16
MP6_B17->Y:OutputBaseAddr1,17
MP6_B18->Y:OutputBaseAddr1,18
MP6_B19->Y:OutputBaseAddr1,19
MP6_B20->Y:OutputBaseAddr1,20
MP6_B21->Y:OutputBaseAddr1,21
MP6_B22->Y:OutputBaseAddr1,22
MP6_B23->Y:OutputBaseAddr1,23
MP6_B24->X:OutputBaseAddr1,0
MP6_B25->X:OutputBaseAddr1,1
MP6_B26->X:OutputBaseAddr1,2
MP6_B27->X:OutputBaseAddr1,3
MP6_B28->X:OutputBaseAddr1,4
MP6_B29->X:OutputBaseAddr1,5
MP6_B30->X:OutputBaseAddr1,6
MP6_B31->X:OutputBaseAddr1,7

// ************************************************
// Inputs - Multiplex Port 9 {TWS:9} M7133-M7165
// ************************************************
MP9_B0->Y:InputBaseAddr2,0
MP9_B1->Y:InputBaseAddr2,1
MP9_B2->Y:InputBaseAddr2,2
MP9_B3->Y:InputBaseAddr2,3
MP9_B4->Y:InputBaseAddr2,4
MP9_B5->Y:InputBaseAddr2,5
MP9_B6->Y:InputBaseAddr2,6
MP9_B7->Y:InputBaseAddr2,7
MP9_B8->Y:InputBaseAddr2,8
MP9_B9->Y:InputBaseAddr2,9
MP9_B10->Y:InputBaseAddr2,10
MP9_B11->Y:InputBaseAddr2,11
MP9_B12->Y:InputBaseAddr2,12
MP9_B13->Y:InputBaseAddr2,13
MP9_B14->Y:InputBaseAddr2,14
MP9_B15->Y:InputBaseAddr2,15
MP9_B16->Y:InputBaseAddr2,16
MP9_B17->Y:InputBaseAddr2,17
MP9_B18->Y:InputBaseAddr2,18
MP9_B19->Y:InputBaseAddr2,19
MP9_B20->Y:InputBaseAddr2,20
MP9_B21->Y:InputBaseAddr2,21
MP9_B22->Y:InputBaseAddr2,22
MP9_B23->Y:InputBaseAddr2,23
MP9_B24->X:InputBaseAddr2,0
MP9_B25->X:InputBaseAddr2,1
MP9_B26->X:InputBaseAddr2,2
MP9_B27->X:InputBaseAddr2,3
MP9_B28->X:InputBaseAddr2,4
MP9_B29->X:InputBaseAddr2,5
MP9_B30->X:InputBaseAddr2,6
MP9_B31->*	//X:InputBaseAddr2,7

#endif

#endif